/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Feb 1, 2009
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.objc.bridge.Wrapper;

import dstep.internal.String;
import dstep.objc.bridge.Bridge;
import dstep.objc.bridge.Capsule;
import dstep.objc.message;
import dstep.objc.objc;
import dstep.objc.runtime;

class ObjcWrapper
{	
	package objc_super* objcSuper;
	
	static private Class objcClass_;
	static private Class objcSuperClass_;
	
	private id objcObject_;
		
	/// Initialize object from an Objective-C object instance to wrap.
	this (id object)
	{
		objcObject_ = object;
		dObject = this;
	}
	
	static Class objcClass ()
	{
		return capsuleClass;
	}
	
	static Class objcSuperClass ()
	{
		if (!objcSuperClass_)
			return objcSuperClass_ = objcClass.getSuperclass;
		
		return objcSuperClass_;
	}
	
	id objcObject ()
	{
		return objcObject_;
	}
	
	protected id objcObject (id object)
	{
		return objcObject_ = object;
	}
	
	protected void dObject (Object dObject)
	{
		Bridge.setDObject(dObject, objcObject);
	}
	
	/*this (bool init = true, bool alloc = true)
	{
		if (init && alloc)
		{
			id result = objc_msgSend!(id)(objc_getClass(this.classinfo.name), sel.registerName!("alloc"));
			id result2;
			
			if (result)
				result2 = objc_msgSend(result, sel.registerName!("init"));
			
			if (result2)
				objc.object = result2;
			
			else
				objc.object = result;
		}
		
		else if (alloc)
			objc.object = objc_msgSend(objc_getClass(this.classinfo.name), sel.registerName!("alloc"));
	}*/
}